#include "mainwindow.h"

MainWindow::MainWindow()
{
    controlPoints = false;
    controlSpeed = false;
    createActions();
    createMenu();
    getLayout();
    //setCursor();

    points->setMouseTracking(true);
    points->pointsSpeed->setMouseTracking(true);
}

void MainWindow::getLayout()
{
    points = new Points;
    points->pointsSpeed = new Speed;
    //speed = new Speed;

    QVBoxLayout *layoutPoints = new QVBoxLayout;
    layoutPoints->addWidget(buttonDrawPoints, 0, Qt::AlignLeft);
    layoutPoints->addWidget(buttonClear, 0, Qt::AlignLeft);
    layoutPoints->addWidget(buttonStartExample, 0, Qt::AlignLeft);
    layoutPoints->addWidget(showPointsF, 0, Qt::AlignLeft);
    layoutPoints->addWidget(showPointsV, 0, Qt::AlignLeft);
    layoutPoints->addStretch();
    QHBoxLayout *mainLayoutPoints = new QHBoxLayout;
    mainLayoutPoints->addLayout(layoutPoints, 0);
    points->setLayout(mainLayoutPoints);


    QVBoxLayout *layoutSpeed = new QVBoxLayout;
    layoutSpeed->addWidget(buttonDrawSpeed, 0, Qt::AlignRight);
    layoutSpeed->addStretch();
    QHBoxLayout *mainLayoutSpeed = new QHBoxLayout;
    mainLayoutSpeed->addLayout(layoutSpeed, 0);
    //speed->setLayout(mainLayoutSpeed);
    points->pointsSpeed->setLayout(mainLayoutSpeed);



    QWidget *window = new QWidget;
    QHBoxLayout *mainLayout = new QHBoxLayout;

    mainLayout->addWidget(points, 0);
    //mainLayout->addWidget(speed, 0);
    mainLayout->addWidget(points->pointsSpeed, 0);

    window->setLayout(mainLayout);
    setCentralWidget(window);
    //setCentralWidget(points1);
    this->setWindowTitle(tr("My Qt project"));
}

void MainWindow::drawPoints()
{
    if(controlPoints == true)
    {
        points->initPoints(myPointVector, N_POINTS);
        points->resizeGL(this->width(), this->height());
        points->updateGL();
        //points->pointsSpeed->resizeGL(this->width(), this->height());
        //points->pointsSpeed->updateGL();
        points->pointsSpeed->timer->start(20);
        points->initFPoint();
    }
    else
    {
        int n = QMessageBox::warning(0, "Warning", "Choose files with coordinates",
                                     "Ok", QString(), 0, 1);
    }
}


void MainWindow::createMenu()
{
    mnFile = menuBar()->addMenu(tr("&Points"));
    mnFile->addAction(saveAction);
    mnFile->addAction(openActionX);
    mnFile->addAction(openActionY);
    mnFile->addAction(openActionZ);
    mnEdit = menuBar()->addMenu(tr("&Speed"));
    mnEdit->addAction(saveAction1);
    mnEdit->addAction(openActionXSpeed);
    mnEdit->addAction(openActionYSpeed);
    mnEdit->addAction(openActionZSpeed);
    //mnService = menuBar()->addMenu(tr("&Options"));
    mnHelp = menuBar()->addMenu(tr("&Info"));
    mnHelp->addAction(showInfo);
    mnHelp->addAction(showTaskInfo);
}

void MainWindow::createActions()
{
    buttonDrawPoints = new QPushButton(tr("DRAW POINTS"));
    buttonClear = new QPushButton(tr("CLEAR"));
    buttonStartExample = new QPushButton(tr("Start example"));
    buttonDrawSpeed = new QPushButton(tr("Plot SPEED"));
    showPointsF = new QCheckBox();
    showPointsV = new QCheckBox();
    showPointsV->setCheckable(true);
    //showPointsF->setTristate(true);
    showPointsF->setFont(QFont("Times", 4, 2, false));
    showPointsF->setText("Fi");
    saveAction = new QAction(tr("&Save"), this);
    saveAction1 = new QAction(tr("&Save"), this);
    openActionX = new QAction(tr("&Open X"), this);
    openActionY = new QAction(tr("&Open Y"), this);
    openActionZ = new QAction(tr("&Open Z"), this);
    openActionXSpeed = new QAction(tr("&Open Speed X"), this);
    openActionYSpeed = new QAction(tr("&Open Speed Y"), this);
    openActionZSpeed = new QAction(tr("&Open Speed Z"), this);
    showInfo = new QAction(tr("&info about program"), this);
    showTaskInfo = new QAction(tr("&info about task"), this);
    ///showInfo->setCheckable(true);
    connect(openActionX, SIGNAL(activated()), this, SLOT(openFileX()));
    connect(openActionY, SIGNAL(activated()), this, SLOT(openFileY()));
    connect(openActionZ, SIGNAL(activated()), this, SLOT(openFileZ()));
    connect(openActionXSpeed, SIGNAL(activated()), this, SLOT(openFileSpeedX()));
    connect(openActionYSpeed, SIGNAL(activated()), this, SLOT(openFileSpeedY()));
    connect(openActionZSpeed, SIGNAL(activated()), this, SLOT(openFileSpeedZ()));
    connect(saveAction, SIGNAL(activated()), this, SLOT(showSaveMenu()));
    connect(saveAction1, SIGNAL(activated()), this, SLOT(showSaveMenu1()));
    connect(buttonDrawPoints, SIGNAL(clicked()), this, SLOT(drawPoints()));
    connect(buttonClear, SIGNAL(clicked()), this, SLOT(clear()));
    connect(buttonStartExample, SIGNAL(clicked()), this, SLOT(startExample()));
    connect(buttonDrawSpeed, SIGNAL(clicked()), this, SLOT(drawSpeed()));
    connect(showPointsF, SIGNAL(stateChanged(int)), this, SLOT(slotShowPointsF()));
    connect(showPointsV, SIGNAL(stateChanged(int)), this, SLOT(slotShowPointsV()));
    connect(showInfo, SIGNAL(activated()), this, SLOT(slotShowInfo()));
    connect(showTaskInfo, SIGNAL(activated()), this, SLOT(slotShowTaskInfo()));
}

void MainWindow::showMessage()
{
    qDebug() << "menu clicked";
}

void MainWindow::openFileX()
{
    QString fileName_DATA = QFileDialog::getOpenFileName(this, tr("Open File"),"",
                                                 tr("TXT (*.txt)"));
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlPoints == false)
    {
        N_POINTS = i;
        myPointVector = new QVector3D*[N_POINTS];
        for(int i = 0; i < N_POINTS; i++)
            myPointVector[i] = new QVector3D;
        for(int i = 0; i < N_POINTS; i++)
        {
            myPointVector[i]->setX(0);
            myPointVector[i]->setY(0);
            myPointVector[i]->setZ(0);
        }
        controlPoints = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        myPointVector[i]->setX(tmp2);
        i++;
    }
}


void MainWindow::openFileY()
{
    QString fileName_DATA = QFileDialog::getOpenFileName(this, tr("Open File"),"",
                                                 tr("TXT (*.txt)"));
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlPoints == false)
    {
        N_POINTS = i;
        myPointVector = new QVector3D*[N_POINTS];
        for(int i = 0; i < N_POINTS; i++)
            myPointVector[i] = new QVector3D;
        for(int i = 0; i < N_POINTS; i++)
        {
            myPointVector[i]->setX(0);
            myPointVector[i]->setY(0);
            myPointVector[i]->setZ(0);
        }
        controlPoints = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        myPointVector[i]->setY(tmp2);
        i++;
    }
}


void MainWindow::openFileZ()
{
    QString fileName_DATA = QFileDialog::getOpenFileName(this, tr("Open File"),"",
                                                 tr("TXT (*.txt)"));
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlPoints == false)
    {
        N_POINTS = i;
        myPointVector = new QVector3D*[N_POINTS];
        for(int i = 0; i < N_POINTS; i++)
            myPointVector[i] = new QVector3D;
        for(int i = 0; i < N_POINTS; i++)
        {
            myPointVector[i]->setX(0);
            myPointVector[i]->setY(0);
            myPointVector[i]->setZ(0);
        }
        controlPoints = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        myPointVector[i]->setZ(tmp2);
        i++;
    }
}

void MainWindow::startExample()
{
    QString fileName_DATA = "x.txt";
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlPoints == false)
    {
        N_POINTS = i;
        myPointVector = new QVector3D*[N_POINTS];
        for(int i = 0; i < N_POINTS; i++)
            myPointVector[i] = new QVector3D;
        for(int i = 0; i < N_POINTS; i++)
        {
            myPointVector[i]->setX(0);
            myPointVector[i]->setY(0);
            myPointVector[i]->setZ(0);
        }
        controlPoints = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        myPointVector[i]->setX(tmp2);
        i++;
    }


    QString fileName_DATA2 = "y.txt";
    QFile file2(fileName_DATA2);
    if (!file2.open(QIODevice::ReadOnly))
    {
        drawPoints();
        return;
    }
    i = 0;
    while(!file2.atEnd())
    {
        tmp = file2.readLine();
        tmp2 = tmp.toFloat();
        myPointVector[i]->setY(tmp2);
        i++;
    }


    QString fileName_DATA3 = "z.txt";
    QFile file3(fileName_DATA3);
    if (!file3.open(QIODevice::ReadOnly))
    {
        drawPoints();
        return;
    }
    i = 0;
    while(!file3.atEnd())
    {
        tmp = file3.readLine();
        tmp2 = tmp.toFloat();
        myPointVector[i]->setZ(tmp2);
        i++;
    }
    drawPoints();
}

void MainWindow::showSaveMenu()
{
    QString filename = QFileDialog::getSaveFileName
            (this, tr("Save Document"), "\D:", tr("Images (*.PNG)") );
    QPixmap pixmap;
    pixmap = QPixmap::grabWidget(this->points);
    pixmap.save(filename, "PNG");
}


void MainWindow::showSaveMenu1()
{
    QString filename = QFileDialog::getSaveFileName
            (this, tr("Save Document"), "\D:", tr("Images (*.PNG)") );
    QPixmap pixmap;
    pixmap = QPixmap::grabWidget(this->points->pointsSpeed);
    pixmap.save(filename, "PNG");
}

void MainWindow::clear()
{
    points->isPaused = true;
    points->clear();
}


void MainWindow::openFileSpeedX()
{
    QString fileName_DATA = QFileDialog::getOpenFileName(this, tr("Open File"),"",
                                                 tr("TXT (*.txt)"));
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlSpeed == false)
    {
        N_SPEED = i;
        mySpeedVector = new QVector3D*[N_SPEED];
        for(int i = 0; i < N_SPEED; i++)
            mySpeedVector[i] = new QVector3D;
        for(int i = 0; i < N_SPEED; i++)
        {
            mySpeedVector[i]->setX(0);
            mySpeedVector[i]->setY(0);
            mySpeedVector[i]->setZ(0);
        }
        controlSpeed = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        mySpeedVector[i]->setX(tmp2);
        i++;
    }
}


void MainWindow::openFileSpeedY()
{
    QString fileName_DATA = QFileDialog::getOpenFileName(this, tr("Open File"),"",
                                                 tr("TXT (*.txt)"));
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlSpeed == false)
    {
        N_SPEED = i;
        mySpeedVector = new QVector3D*[N_SPEED];
        for(int i = 0; i < N_SPEED; i++)
            mySpeedVector[i] = new QVector3D;
        for(int i = 0; i < N_SPEED; i++)
        {
            mySpeedVector[i]->setX(0);
            mySpeedVector[i]->setY(0);
            mySpeedVector[i]->setZ(0);
        }
        controlSpeed = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        mySpeedVector[i]->setY(tmp2);
        i++;
    }
}


void MainWindow::openFileSpeedZ()
{
    QString fileName_DATA = QFileDialog::getOpenFileName(this, tr("Open File"),"",
                                                 tr("TXT (*.txt)"));
    QFile file(fileName_DATA);
    if (!file.open(QIODevice::ReadOnly))
    {
        return;
    }
    long i = 0;
    while(!file.atEnd())
    {
        file.readLine();
        i++;
    }
    if(controlSpeed == false)
    {
        N_SPEED = i;
        mySpeedVector = new QVector3D*[N_SPEED];
        for(int i = 0; i < N_SPEED; i++)
            mySpeedVector[i] = new QVector3D;
        for(int i = 0; i < N_SPEED; i++)
        {
            mySpeedVector[i]->setX(0);
            mySpeedVector[i]->setY(0);
            mySpeedVector[i]->setZ(0);
        }
        controlSpeed = true;
    }
    file.close();
    QFile file1(fileName_DATA);
    file1.open(QIODevice::ReadOnly);
    QString tmp;
    float tmp2;
    i = 0;
    while(!file1.atEnd())
    {
        tmp = file1.readLine();
        tmp2 = tmp.toFloat();
        mySpeedVector[i]->setZ(tmp2);
        i++;
    }
}

void MainWindow::drawSpeed()
{

    if(controlSpeed == true)
    {

        points->pointsSpeed->initSpeed(mySpeedVector, N_SPEED);
        points->pointsSpeed->updateGL();
    }
    else
    {
        int n = QMessageBox::warning(0, "Warning", "Choose files with speed coordinates",
                                     "Ok", QString(), 0, 1);
    }
}

void MainWindow::slotShowPointsF()
{
    points->showF = !points->showF;
}


void MainWindow::slotShowPointsV()
{
    points->showV = !points->showV;
}

void MainWindow::slotShowInfo()
{
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("CP1251"));
    QMessageBox::information(0, "Info about program",
                             "   /   png - \n   Points / Speed.\n"
                             "      / .\n"
                             "   -    .\n"
                             "     ,  checkbox ( ).\n"
                             "   ( ) -  .\n "
                             "    ( ) -   .\n"
                             "        , "
                             "   ,     ,     ,  "
                             " ,   Plot SPEED   "
                             , "ok", 0);
}

void MainWindow::slotShowTaskInfo()
{/*
    QMessageBox::information(0, "Info", "Choose files with coordinates",
                                         "Ok", QString(), 0, 1);*/
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("CP1251"));
    QMessageBox::information(0, "Info about task", "         .\n"
                             "1)   ,   .   -       .\n"
                             "2)   , ,    ,  (   ).       (png),   ,      .\n"
                             "3)     .    , c      (png),     .", "ok", 0);
}

