#include "points.h"
#include <math.h>
#include <time.h>

const double PI = 3.1415926535897932384626433832795;
const double G = 6.67428e-11;

static long k = 0;
static long t = 0;

Points::Points(QGLWidget* parent) : Scene3D(parent)
{
    showF = false;
    //xRot=-90; yRot=0; zRot=0; zTra=0; nSca=1;
    //xRot = -110;
    //zRot = 110;
    //xRot = 90, zRot = -90;
    xRot = -70;
    zRot = -30;
    controlClear = false;
    //L = 1;
    //L = 25;
    N_POINTS = 0;
    nInfo = -1;
    myFPointVector = new QVector3D*[N_POINTS];
    for(int i = 0; i< N_POINTS; i++)
    {
        myFPointVector[i] = new QVector3D;
        myFPointVector[i]->setX(0);
        myFPointVector[i]->setY(0);
        myFPointVector[i]->setZ(0);
    }
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(change()));
    //timer->start(20);
}

void Points::change()
{

//    analizePoints();
    if(isPaused == false)
    {
    m = 1 / sqrt(G) * L * 1e7;
    pointInformation();
    //initFPoint();
    double dt = 1e-3;
    for (int i = 0; i < N_POINTS - 1; i++)
    {
        for (int j = i + 1; j < N_POINTS; j++)
        {
            myAPointVector_[i] = myAPointVector_[i] + (myPointVector_[j] - myPointVector_[i])
                    * (G * masMPoint[j] / pow((myPointVector_[j] - myPointVector_[i]).abs(), 3));
            myAPointVector_[j] = myAPointVector_[j] +
                    myAPointVector_[i] * (-masMPoint[i] / masMPoint[j]);

        }
    }
    for(int i = 0; i < N_POINTS; i++)
    {
        myFPointVector_[i] = myAPointVector_[i] * masMPoint[i];
    }
    for (int i = 0; i < N_POINTS; i++)
    {
        //if(t < 1 && pointsSpeed->N_SPEED > 0)
        //{
            myVPointVector_[i].x = pointsSpeed->mySpeedVector[i]->x() + myAPointVector_[i].x * dt;
                    //myVPointVector_[i].x;
            myVPointVector_[i].y = pointsSpeed->mySpeedVector[i]->y() + myAPointVector_[i].y * dt;
                    //myVPointVector_[i].y;
            myVPointVector_[i].z = pointsSpeed->mySpeedVector[i]->z() + myAPointVector_[i].z * dt;
                    //myVPointVector_[i].z;
        //}
        //myVPointVector_[i] = myVPointVector_[i] + myAPointVector_[i] * dt;
        myPointVector_[i] = myPointVector_[i]
                + myVPointVector_[i] * dt;
        myPointVector[i]->setX(myPointVector_[i].x);
        myPointVector[i]->setY(myPointVector_[i].y);
        myPointVector[i]->setZ(myPointVector_[i].z);
        myAPointVector_[i] = myVector3D(0, 0, 0);

        myVPointVector[i]->setX(myVPointVector_[i].x);
        myVPointVector[i]->setY(myVPointVector_[i].y);
        myVPointVector[i]->setZ(myVPointVector_[i].z);
    }
    drawPoints();
    //qDebug() << myPointVector[5]->x();
    updateGL();
    t++;
    }

    pointsSpeed->initSpeed(myVPointVector, N_POINTS);

}

void Points::drawAxis()
{
    double L_ = 1.2 * L;
    glPushMatrix();
    //glPushAttrib();
    //glutSetColor(0, 1, 1, 0);
    glLineWidth(3.0f);

    glColor4f(1.00f, 0.00f, 0.00f, 1.0f);
    glBegin(GL_LINES);
    glVertex3f(L_,  0.0f,  0.0f);
    glVertex3f(-L_,  0.0f,  0.0f);
    glEnd();

    glColor4f(0, 1, 0, 1);
    glBegin(GL_LINES);
    glVertex3f( 0.0f,  L_,  0.0f);
    glVertex3f( 0.0f, -L_,  0.0f);

    glColor4f(0.00f, 0.00f, 1.00f, 1.0f);
    glVertex3f( 0.0f,  0.0f, L_);
    glVertex3f( 0.0f,  0.0f, -L_);
    glEnd();

    glPopMatrix();
    //glPopAttrib();

    /*
    glBegin(GL_TRIANGLES);
    glVertex3f(L,  0.0f, 0.0f);
    glVertex3f(L-0.01*L,  0.01*L, 0.0f);
    glEnd();
    */

    glPushMatrix();
    glTranslated(L_, 0, 0);
    glRotated(90, 0, 1, 0);
    glutSolidCone(L / 50.0, L / 10.0, 10, 10);
    glPopMatrix();

    glPushMatrix();
    glTranslated(0, -L_, 0);
    glRotated(90, 1, 0, 0);
    glutSolidCone(L / 50.0, L / 10.0, 10, 10);
    glPopMatrix();

    glPushMatrix();
    glTranslated(0, 0, L_);
    glutSolidCone(L / 50.0, L / 10.0, 10, 10);
    glPopMatrix();
}

void Points::drawPoints()
{
    R = L/100.0;
    controlClear = false;
    //glPointSize(4.0f);
    glColor4f(0.00f, 1.00f, 0.00f, 1.0f);
    //glBegin(GL_POINTS);
    for(int i = 0; i < N_POINTS; i++)
    {
        /*
        glVertex3f(myPointVector[i]->x(),
                   myPointVector[i]->y(),
                   myPointVector[i]->z());
                   */
        glPushMatrix();
        glTranslated( myPointVector[i]->x(),
                      myPointVector[i]->y(),
                      myPointVector[i]->z() );
        //glScaled(nSca, nSca, nSca);
        glutWireSphere(R, 10, 10);
        glPopMatrix();
        glLineWidth(3);

        if(showF == true && k > 1)
        {
            glBegin(GL_LINES);
            //glutSetColor(1, 1, 0, 0);
            glVertex3d(myPointVector[i]->x(), myPointVector[i]->y(), myPointVector[i]->z());
            glVertex3d( 1 / m * myFPointVector_[i].x + myPointVector[i]->x(),
                        1 / m * myFPointVector_[i].y + myPointVector[i]->y() ,
                        1 / m * myFPointVector_[i].z + myPointVector[i]->z() );
            //glVertex3d(0, 0, 0.5);
            glEnd();
        }
        if(showV == true && k > 1)
        {
            glBegin(GL_LINES);
            //glutSetColor(1, 1, 0, 0);
            glVertex3d(myPointVector[i]->x(), myPointVector[i]->y(), myPointVector[i]->z());
            glVertex3d( myVPointVector_[i].x + myPointVector[i]->x(),
                        myVPointVector_[i].y + myPointVector[i]->y() ,
                        myVPointVector_[i].z + myPointVector[i]->z() );
            //glVertex3d(0, 0, 0.5);
            glEnd();
        }

    }
    //glEnd();
    k++;
}

void Points::initPoints(QVector3D **point, int n)
{
    myPointVector = new QVector3D*[n];
    for(int i = 0; i < n; i++)
        myPointVector[i] = new QVector3D;
    for(int i = 0; i < n; i++)
    {
        myPointVector[i]->setX(point[i]->x());
        myPointVector[i]->setY(point[i]->y());
        myPointVector[i]->setZ(point[i]->z());
    }

    N_POINTS = n;

    analizePoints();
    drawPoints();
    initFPoint();
    //pointsSpeed->initSpeedOfPoints(this->myVPointVector_, N_POINTS);
    if(pointsSpeed->N_SPEED == 0)
        pointsSpeed->initSpeed(myVPointVector, N_POINTS);
    //pointsSpeed->updateGL();
    timer->start(20);
    //pointsSpeed->timer->start(20);
}

void Points::initializeGL()
{
    qglClearColor(Qt::black);
    /*
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_FLAT);
    glEnable(GL_CULL_FACE);
    //glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
    */

    glClearColor(0.0, 0.0, 0.0, 1.0); //    - 
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_SMOOTH);
    //glShadeModel(GL_EQUAL);

    float lightAmb[4] = {2, 2, 0, 1};
    float lightDif[4] = {6, 0.0, 0.0, 1};
    float lightPos[4] = {0.0, 3.0, 3.0, 1};
    glLightfv (GL_LIGHT0, GL_AMBIENT, lightAmb);
    glLightfv (GL_LIGHT0, GL_DIFFUSE, lightDif);
    glLightfv (GL_LIGHT0, GL_POSITION, lightPos);
    glEnable (GL_LIGHT0 );
    glEnable (GL_LIGHTING);
}

void Points::resizeGL(int nWidth, int nHeight)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    GLfloat ratio=(GLfloat)nHeight/(GLfloat)nWidth;
    ratio = 1.0;
    if (nWidth>=nHeight)
        glOrtho(-L/ratio, L/ratio, -L, L, -10*L, 10*L);
    else
        glOrtho(L, L, L*ratio, L*ratio, -10*L, 10*L);
    //glViewport(0, 0, (GLint)nWidth, (GLint)nHeight);
    glViewport(0, 0, this->width(), this->height());
}

void Points::paintGL()
{
    //double* x = Speed::masDN;
    //double x = Speed::N_PLOT;
    //Speed q;
    //qDebug() << q.N_SPEED;
    //qDebug() << "xRot " << xRot << " yRot " << yRot << " zRot " << zRot;
    /*
    if(N != 0)
    {
        qDebug() << " mouseX "
        << (mousePosition.x() - width() / 2.0) / (width() / 2.0) * L / nSca
        << " mouseY "
        << -(mousePosition.y() - height() / 2.0) / (height() / 2.0) * L / nSca
        << " xPoint " << myPointVector[1]->x()
        << " yPoint " << myPointVector[1]->z();
    }
    */
//    qDebug() << myPointVector[1];
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glScalef(nSca, nSca, nSca);
    glTranslatef(0.0f, zTra, 0.0f);
    glRotatef(xRot, 1.0f, 0.0f, 0.0f);
    glRotatef(yRot, 0.0f, 1.0f, 0.0f);
    glRotatef(zRot, 0.0f, 0.0f, 1.0f);

    if(controlClear == false)
    {
        if(k > 0)
        {
            drawAxis();
            drawPoints();
        }
    }
    pointInformation();
}

void Points::clear()
{
    controlClear = true;
    this->updateGL();
}

void Points::analizePoints()
{
    double maxX = fabs(myPointVector[0]->x()), maxY = fabs(myPointVector[0]->y()),
            maxZ = fabs(myPointVector[0]->z());
    for(int i = 0; i < N_POINTS; i++)
    {
        if(fabs(myPointVector[i]->x()) > maxX)
            maxX = fabs(myPointVector[i]->x());
        if(fabs(myPointVector[i]->y()) > maxY)
            maxY = fabs(myPointVector[i]->y());
        if(fabs(myPointVector[i]->z()) > maxZ)
            maxZ = fabs(myPointVector[i]->z());
    }
    L = maxFunc(maxX, maxY, maxZ);
}

double Points::pointInformation()
{
    bool control = false;
    if(controlClear == false)
    {
        double W = this->width(), H = this->height();
        for(int i = 0; i < N_POINTS; i++)
        {
            double dx, dz, x, z, y, xM, yM;
            QVector3D * tmp = new QVector3D[N_POINTS];
            tmp = myPointVector[i];
            x = tmp->x() * cos(zRot / 180.0 * PI) - tmp->y() * sin(zRot / 180.0 * PI);
            z = tmp->z() * cos((xRot + 90) / 180.0 * PI) -
                    tmp->x() * sin((xRot + 90) / 180.0 * PI) * sin(-zRot / 180.0 * PI) +
                    tmp->y() * sin((xRot + 90) / 180.0 * PI) * cos(zRot / 180.0 * PI);
            xM = (mousePosition.x() - (double)this->width() / 2.0)
                    * L / nSca
                    /((double)this->width() / 2.0);
            yM = -(mousePosition.y() - (double)this->height() / 2.0)
                    * L / nSca
                    /((double)this->height() / 2.0);
            dx = x - xM;
            dz = z - yM;
            if(dx*dx + dz*dz < R * R)
            {
                nInfo = i;

                renderText(tmp->x(), tmp->y(), tmp->z(),
                           QString::fromStdString("Point_%1 (%2, %3, %4)")
                           .arg(nInfo)
                           .arg(tmp->x())
                           .arg(tmp->y())
                           .arg(tmp->z()),
                           QFont("Times", L * 13.0 / 100.0 * pow((double)nSca, 0.3)), 0);


                if(k > 1)
                {
                    glBegin(GL_LINES);
                    glVertex3d(myPointVector[i]->x(), myPointVector[i]->y(), myPointVector[i]->z());
                    glVertex3d( 1 / m * myFPointVector_[i].x + myPointVector[i]->x(),
                                1 / m * myFPointVector_[i].y + myPointVector[i]->y() ,
                                1 / m * myFPointVector_[i].z + myPointVector[i]->z() );
                    glEnd();
                    glBegin(GL_LINES);
                    glVertex3d(myPointVector[i]->x(), myPointVector[i]->y(), myPointVector[i]->z());
                    glVertex3d( myVPointVector_[i].x + myPointVector[i]->x(),
                                myVPointVector_[i].y + myPointVector[i]->y() ,
                                myVPointVector_[i].z + myPointVector[i]->z() );
                    glEnd();
                }
                pointsSpeed->showInf = i;
                control = true;
            }
        }
    }
    if(control == false)
        pointsSpeed->showInf = -1;
}

void Points::initFPoint()
{

    //m = 1 / sqrt(G) * L * 1e2;

    m = 1 / sqrt(G) * L * 1e7;
    masMPoint = new double[N_POINTS];
    myAPointVector = new QVector3D*[N_POINTS];
    myVPointVector = new QVector3D*[N_POINTS];
    //myFPointVector = new QVector3D*[N_POINTS];
    myPointVector_ = new myVector3D[N_POINTS];
    myVPointVector_ = new myVector3D [N_POINTS];
    myAPointVector_ = new myVector3D[N_POINTS];
    myFPointVector_= new myVector3D[N_POINTS];


    for(int i = 0; i < N_POINTS; i++)
    {
        myVPointVector_[i].init(0, 0, 0);
        myPointVector_[i].init(myPointVector[i]->x(),
                               myPointVector[i]->y(),
                               myPointVector[i]->z());
        masMPoint[i] = m;
        myAPointVector[i] = new QVector3D;
        myAPointVector[i]->setX(0), myAPointVector[i]->setY(0), myAPointVector[i]->setZ(0);
        myVPointVector[i] = new QVector3D;
        myVPointVector[i]->setX(0), myVPointVector[i]->setY(0), myVPointVector[i]->setZ(0);
        //myFPointVector[i] = new QVector3D;
        //myFPointVector[i]->setX(0), myFPointVector[i]->setY(0), myFPointVector[i]->setZ(0);
        myPointVector_[i].init(myPointVector[i]->x(), myPointVector[i]->y(),
                               myPointVector[i]->z());
        /*myAPointVector_[i].init(myAPointVector[i]->x(), myAPointVector[i]->y(),
                               myAPointVector[i]->z());*/
        myAPointVector_[i].init(0, 0, 0);

        myFPointVector_[i].init(0, 0, 0);
    }

    //qDebug() << myAPointVector_[0].x << myAPointVector_[0].y << myAPointVector_[0].z;



    double dt = 1e-3;

    long number = 0;

    /*
    double cursorx1 = cursor.pos().x();
    double cursory1 = cursor.pos().y();
    */

         //updateGL();
        qDebug() << number << myVPointVector_[3].x;
        drawPoints();

        qDebug() << "nSca (points) " << nSca;
        updateGL();
        number++;
}

