#include "speed.h"
#include <math.h>
const double PI = 3.1415926535897932384626433832795;

static long k = 0;

Speed::Speed(QGLWidget* parent) : Scene3D(parent)
{
    showInf = false;
    xRot=-90; yRot=0; zRot=0; zTra=0; nSca=1;
    controlClear = false;
    //L = 1;
    //L = 25;
    N_SPEED = 0;
    nInfo = -1;
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(change()));
    timer->start(20);
}

void Speed::change()
{
    leftButtonPressed = false;

    if(N_SPEED > 0)
    {
        analizeSpeed();
        plotSpeed();
        //qDebug() << masDV[3];
    }

    this->updateGL();
    resizeGL(width(), height());

    //Points::myAPointVector[0]->x();
}

/*
void Speed::wheelEvent(QWheelEvent* pe)
{
    if ((pe->delta()) < 0)
        scale_plus();
    else
        if ((pe->delta()) > 0)
            scale_minus();
    updateGL();
}
*/
void Speed::drawAxis()
{
    double L_ = 1.2 * L;
    glPushMatrix();
    //glPushAttrib();
    //glutSetColor(0, 1, 1, 0);
    glLineWidth(3.0f);


    glColor4f(1.00f, 0.00f, 0.00f, 1.0f);
    glBegin(GL_LINES);

    glVertex3f(L_,  0.0f,  0.0f);
    glVertex3f(-L_,  0.0f,  0.0f);

    //glEnd();

    glColor4f(0.00f, 0.00f, 1.00f, 1.0f);
    glVertex3f( 0.0f,  0.0f, L_);
    glVertex3f( 0.0f,  0.0f, -L_);

    glEnd();
    glColor4f(1.00f, 0.00f, 0.00f, 1.0f);


    static QString xAxis, yAxis;
    if(fabs(mapFromGlobal(cursor.pos()).x() - (double)width() / 2.0) < 10
            && leftButtonPressed == true)
    {
        yAxis = QInputDialog::getText(this, tr("y Axis"),
                                             tr("name"), QLineEdit::Normal,
                                             "");
        leftButtonPressed = false;
    }

    if(fabs(mapFromGlobal(cursor.pos()).y() - (double)height() / 2.0) < 10
            && leftButtonPressed == true)
    {
        xAxis = QInputDialog::getText(this, tr("x Axis"),
                                             tr("name"), QLineEdit::Normal,
                                             "");
        leftButtonPressed = false;
    }

    renderText(L_, 0, L / 50, xAxis,
               QFont("Times", 10), 0);

    renderText(L / 50, 0, L_, yAxis,
               QFont("Times", 10), 0);

    glPopMatrix();
    //glPopAttrib();

    /*
    glBegin(GL_TRIANGLES);
    glVertex3f(L,  0.0f, 0.0f);
    glVertex3f(L-0.01*L,  0.01*L, 0.0f);
    glEnd();
    */

    glPushMatrix();
    glTranslated(L_, 0, 0);
    glRotated(90, 0, 1, 0);
    glutSolidCone(L / 50.0, L / 10.0, 10, 10);
    glPopMatrix();

    /*
    glPushMatrix();
    glTranslated(0, -L_, 0);
    glRotated(90, 1, 0, 0);
    glutSolidCone(L / 25.0, L / 10.0, 10, 10);
    glPopMatrix();
    */

    glPushMatrix();
    glTranslated(0, 0, L_);
    glutSolidCone(L / 50.0, L / 10.0, 10, 10);
    glPopMatrix();

    qDebug() << "length of axis is L = " << L;
}

void Speed::plotSpeed()
{
    R = 1;
    controlClear = false;
    //glPointSize(4.0f);
    glColor4f(0.00f, 1.00f, 0.00f, 1.0f);
    glLineWidth(5.0);
//    glBegin(GL_POINTS);
//    glutSolidSphere(10, 10, 10);
    glBegin(GL_LINE_STRIP);
    for(int i = 0; i < N_PLOT; i++)
    {
        /*
        glVertex3f(myPointVector[i]->x(),
                   myPointVector[i]->y(),
                   myPointVector[i]->z());
                   */
//        glPushMatrix();
//        glTranslated( masDV[i],
//                      0,
//                      masDN[i] / (double)analizeSpeed() * N_PLOT);

//        glutWireSphere(R, 10, 10);
//        glPopMatrix();
//        qDebug() << "vPlotMax " << maxVPlot << " maxNPlot " << maxNPlot;
        glVertex3d(masDV[i] / maxVPlot * L, 0, masDN[i] / maxNPlot * L);
    }
    glEnd();
    if(showInf >= 0)
    {
        renderText(-100, 0, 100,
                   QString::fromStdString("Speed (%1, %2, %3)")
                   .arg(mySpeedVector[showInf]->x())
                   .arg(mySpeedVector[showInf]->y())
                   .arg(mySpeedVector[showInf]->z()),
                   QFont("Times", 10), 0);
    }
    k++;
}

void Speed::initSpeed(QVector3D **point, int n)
{
    mySpeedVector = new QVector3D*[n];

    for(int i = 0; i < n; i++)
        mySpeedVector[i] = new QVector3D;

    for(int i = 0; i < n; i++)
    {
        mySpeedVector[i]->setX(point[i]->x());
        mySpeedVector[i]->setY(point[i]->y());
        mySpeedVector[i]->setZ(point[i]->z());
    }

    //timer->start(20);
    N_SPEED = n;
    //analizeSpeed();
    //plotSpeed();
    //timer->start(20);
    qDebug() << N_SPEED;
}

void Speed::initializeGL()
{
    qglClearColor(Qt::black);
    /*
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_FLAT);
    glEnable(GL_CULL_FACE);
    //glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
    */

    glClearColor(0.0, 0.0, 0.0, 1.0);
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_SMOOTH);

    float lightAmb[4] = {2, 2, 0, 1};
    float lightDif[4] = {6, 0.0, 0.0, 1};
    float lightPos[4] = {0.0, 3.0, 3.0, 1};
    glLightfv (GL_LIGHT0, GL_AMBIENT, lightAmb);
    glLightfv (GL_LIGHT0, GL_DIFFUSE, lightDif);
    glLightfv (GL_LIGHT0, GL_POSITION, lightPos);
    glEnable (GL_LIGHT0 );
    glEnable (GL_LIGHTING);
}

void Speed::resizeGL(int nWidth, int nHeight)
{
    glMatrixMode(GL_MODELVIEW);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    GLfloat ratio=(GLfloat)nHeight/(GLfloat)nWidth;
    ratio = 1.0;
    if (nWidth>=nHeight)
        glOrtho(-1.5*L/ratio, 1.5*L/ratio, -1.5*L, 1.5*L, -10*L, 10*L);
    else
        glOrtho(-1.5*L, 1.5*L, -1.5*L*ratio, 1.5*L*ratio, -10*L, 10*L);
    //glViewport(0, 0, (GLint)nWidth, (GLint)nHeight);
    glViewport(0, 0, this->width(), this->height());


    qDebug() << "L is " << L;
}

void Speed::paintGL()
{
    qDebug() << "speed gl paint";
    //qDebug() << "xRot " << xRot << " yRot " << yRot << " zRot " << zRot;
    /*
    if(N != 0)
    {
        qDebug() << " mouseX "
        << (mousePosition.x() - width() / 2.0) / (width() / 2.0) * L / nSca
        << " mouseY "
        << -(mousePosition.y() - height() / 2.0) / (height() / 2.0) * L / nSca
        << " xPoint " << myPointVector[1]->x()
        << " yPoint " << myPointVector[1]->z();
    }
    */
//    qDebug() << myPointVector[1];
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glScalef(nSca, nSca, nSca);
    glTranslatef(0.0f, zTra, 0.0f);
    glRotatef(xRot, 1.0f, 0.0f, 0.0f);
    glRotatef(yRot, 0.0f, 1.0f, 0.0f);
    glRotatef(zRot, 0.0f, 0.0f, 1.0f);

    //glutSolidSphere(1, 1, 1);

    if(controlClear == false)
    {
        if(k > 0)
        {
            drawAxis();
            plotSpeed();
            qDebug() << "DRAW AXIS !!!";
        }
    }
    //pointInformation();
}

void Speed::clear()
{
    controlClear = true;
    this->updateGL();
}

double Speed::analizeSpeed()
{
    static int q = 0;
    masAbsV = new double[N_SPEED];
    for(int i = 0; i < N_SPEED; i++)
    {
        masAbsV[i] = sqrt(pow(mySpeedVector[i]->x(), 2)+
                          pow(mySpeedVector[i]->y(), 2) +
                          pow(mySpeedVector[i]->z(), 2));
    }
    double maxV = masAbsV[0];
    for(int i = 0; i < N_SPEED; i++)
    {
        if(masAbsV[i] > maxV)
            maxV = masAbsV[i];
    }
    double v, dv = 2 * (double)maxV / (double)N_SPEED;
    int N = N_SPEED;
    double * tmpMas_dN = new double[N];
    for (int i = 0; i < N; i++)
    {
        tmpMas_dN[i] = 0;
    }
    int k = 0;
    int i = 0;
    double * masDV_ = new double[N];
    double * masDN_ = new double[N];
    for(v = -dv; v < maxV + dv; v += dv)
    {
        tmpMas_dN[i] = (double)funcN(masAbsV, v, dv, N);
        if(tmpMas_dN[i] != 0)
        {
            masDV_[k] = v;
            masDN_[k] = (double)tmpMas_dN[i] / dv / double(N);
            k++;
        }
        i++;
        if(i == N)
            break;
    }
    N_PLOT = k;
    masDV = new double[N_PLOT];
    masDN = new double[N_PLOT];
    for(int i = 0; i < N_PLOT; i++)
    {
        masDV[i] = masDV_[i];
        masDN[i] = masDN_[i];
    }
    maxVPlot = masDV[0], maxNPlot = masDN[0];
    for(int i = 0; i < N_PLOT; i++)
    {
        if(maxVPlot < masDV[i])
            maxVPlot = masDV[i];
        if(maxNPlot < masDN[i])
            maxNPlot = masDN[i];
    }
//    L = max(maxVPlot, 10000 * maxNPlot / N_PLOT, 0);

    //L = max(maxVPlot, maxNPlot, 0);
    L = 100;

    //qDebug() << "L " << L << " masDV " << masDV[N_PLOT - 1];
    return dv;
    q++;
}

double Speed::speedInformation()
{
    if(controlClear == false)
    {
        double W = this->width(), H = this->height();
        for(int i = 0; i < N_SPEED; i++)
        {
            double dx, dz, x, z, y, xM, yM;
            QVector3D * tmp = new QVector3D[N_SPEED];
            tmp = mySpeedVector[i];
            x = tmp->x() * cos(zRot / 180.0 * PI) - tmp->y() * sin(zRot / 180.0 * PI);
            z = tmp->z() * cos((xRot + 90) / 180.0 * PI) -
                    tmp->x() * sin((xRot + 90) / 180.0 * PI) * sin(-zRot / 180.0 * PI) +
                    tmp->y() * sin((xRot + 90) / 180.0 * PI) * cos(zRot / 180.0 * PI);

            xM = (mousePosition.x() - (double)this->width() / 2.0)
                    * L / nSca
                    /((double)this->width() / 2.0);
            yM = -(mousePosition.y() - (double)this->height() / 2.0)
                    * L / nSca
                    /((double)this->height() / 2.0);
            qDebug() << "xM " << xM << " yM " << yM;
            qDebug() << "w " << width() << " h " << height();
            dx = x - xM;
            dz = z - yM;
            if(dx*dx + dz*dz < R * R)
            {
                nInfo = i;
                renderText(tmp->x(), tmp->y(), tmp->z(),
                           QString::fromStdString("Point_%1 (%2, %3, %4)")
                           .arg(nInfo)
                           .arg(tmp->x())
                           .arg(tmp->y())
                           .arg(tmp->z()),
                           QFont("Times", 13 * pow((double)nSca, 0.3)), 0);
            }
        }
    }
}

void Speed::initSpeedOfPoints(myVector3D *v, long N)
{
    if(N_SPEED == 0)
    {
        mySpeedVector = new QVector3D * [N];
        for(int i = 0; i < N; i++)
        {
            mySpeedVector[i] = new QVector3D;
            mySpeedVector[i]->setX((v + i)->x);
            mySpeedVector[i]->setY((v + i)->y);
            mySpeedVector[i]->setZ((v + i)->z);
        }
        N_SPEED = N;

    }
}
